#!/bin/bash
# IP Updater Script Helper v0.4 by DPX-Infinity, 2009
# Restores connection and updates IP address

# <edit here>
# connection commands
CONN_UP='echo Starting connection'   # command by which you start connection
CONN_DOWN='echo Stopping connection' # stop connection
# </edit here>

UPDPATH=`dirname $0`/ipupdater.py
PINGPATH=`dirname $0`/ping.py

function show_help(){
	echo 'Usage:'
	echo './ipupdater.sh ping <address> - using ping command'
	echo './ipupdater.sh connect <address[:port]> - using ping.py script'
	echo './ipupdater.sh link <iface> - using ifconfig'
	echo './ipupdater.sh pid <iface> - using pid file check'
	echo './ipupdater.sh proc <iface> - using /proc/net/dev'
	echo '	<address> - any address or name'
	echo '	<port> - TCP port value'
	echo '	<iface> - correct network interface name, e.g. ppp0'
	exit
}

if [ "$1" = "help" -o "$1" = "-h" -o "$1" = "--help" -o \( $# -lt 2 \) ]; then
	show_help
fi

if [ -n "$2" ]; then # got second argument
	if [ "$1" = "ping" ]; then # using ping command
		ping -c4 $2 > /dev/null 2>&1
		X=$?
	elif [ "$1" = "connect" ]; then # using ping.py script; host may be in host:port form
		HOST=`echo $2 | awk -F: '{print $1}'`
		PORT=`echo $2 | awk -F: '{print $2}'`
		PORT=${PORT:-80}
		python $PINGPATH $HOST $PORT > /dev/null 2>&1
		X=$?
	elif [ "$1" = "link" ]; then # using ifconfig
		/sbin/ifconfig | grep "$2" > /dev/null 2>&1 # $2 == link
		X=$?
	elif [ "$1" = "pid" ]; then # using pid file check
		/bin/ls /var/run | /bin/grep "$2.pid" > /dev/null 2>&1 # $2 == link
		X=$?
	elif [ "$1" = "proc" ]; then # using /proc/net/dev
		/bin/grep "$2" /proc/net/dev > /dev/null 2>&1 # $2 == link
		X=$?
	else
		show_help
	fi
else
	show_help
fi

if (($X)); then
	$CONN_DOWN
	sleep 1s
	$CONN_UP
	sleep 1s
fi

# finally, updating
python $UPDPATH
