#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Ping Script v0.1 by DPX-Infinity, 2009
# Pings target by connecting to specified TCP port

# Executing:
# ./ping.py <address> [port [timeout]]
#   port - needed port (default 80)
#   timeout - needed timeout in seconds (default 3)

import socket as s
import sys

if len(sys.argv)<2: # incorrect params
	print >>sys.stderr, "Incorrect parameters!"
	sys.exit(1)

host = sys.argv[1]
port = 80
s.setdefaulttimeout(3)
if len(sys.argv)>=3:
	port = int(sys.argv[2])
if len(sys.argv)>=4:
	s.setdefaulttimeout(int(sys.argv[3]))

try:
	sock = s.socket(s.AF_INET, s.SOCK_STREAM)
	sock.connect((host,port))
	if port in [80, 8080]: # additional check for HTTP servers
		sock.send("GET / HTTP/1.1\r\nHost: %s\r\nConnection: close\r\n\r\n")
		if not len(sock.recv(200)):
			raise Exception
	sock.shutdown(s.SHUT_RDWR)
	sock.close()
except:
	sock.close()
	sys.exit(1)

sys.exit(0)
